Enumeration
  #mnu_s10
  #mnu_s20
  #mnu_color
  #mnu_exit
EndEnumeration


Global ws.l=20
Global col.l=RGB(0,255,0)
;read settings
If FileSize("dc.dat")>0
  If ReadFile(0,"dc.dat")
    ws=ReadLong(0)
    col=ReadLong(0)
    CloseFile(0)
    
  EndIf
EndIf

If CreatePopupMenu(0)
  OpenSubMenu("Rect size")
  MenuItem(#mnu_s10, "10")
  MenuItem(#mnu_s20, "20")
  CloseSubMenu()
  MenuItem(#mnu_color, "Color..")
  MenuBar()
  MenuItem(#mnu_exit, "Exit")
Else
  MessageRequester("Oops!","it happens with menu",#PB_MessageRequester_Ok)
  End
EndIf

If ws=10
  SetMenuItemState(0,#mnu_s10,1)
Else
  SetMenuItemState(0,#mnu_s20,1)
EndIf

OpenWindow(0,ws,ws,ws*6,ws*4,"",#PB_Window_BorderLess | #PB_Window_SystemMenu ! #PB_Window_TitleBar | #WS_POPUP | #PB_Window_Invisible)

SetRect_(moverect.RECT,0,0,ws*6,ws*4)
StickyWindow(0, 1)


Global r.RECT
;GetWindowRect_(WindowID(0),r)
r\left=0
r\top=0
r\right=1
r\bottom=1

wrgn.l=CreateRectRgnIndirect_(r)
SetWindowRgn_(WindowID(0),wrgn,1)
DeleteObject_(wrgn)

; wrgn.l=CreateRectRgnIndirect_(r)
; hrgn.l=CreateRectRgn_(0,0,9,9)
; CombineRgn_(wrgn, wrgn, hrgn, #RGN_OR)
; DeleteObject_(hrgn)
; 
; hrgn.l=CreateRectRgn_(0,10,9,19)
; CombineRgn_(wrgn, wrgn, hrgn, #RGN_OR)
; DeleteObject_(hrgn)
; 
; SetWindowRgn_(WindowID(0),wrgn,1)
; 
; DeleteObject_(wrgn)

SetWindowLong_(WindowID(0), #GWL_EXSTYLE, #WS_EX_TOOLWINDOW)
HideWindow(0, 0)


Global hwndTT.l = CreateWindowEx_(#WS_EX_TOPMOST, #TOOLTIPS_CLASS, 0,#WS_POPUP | #TTS_NOPREFIX | #TTS_ALWAYSTIP,#CW_USEDEFAULT, #CW_USEDEFAULT, #CW_USEDEFAULT, #CW_USEDEFAULT,WindowID(0), 0, GetModuleHandle_(0),0)

SetWindowPos_(hwndTT, #HWND_TOPMOST, 0, 0, 0, 0, #SWP_NOMOVE | #SWP_NOSIZE | #SWP_NOACTIVATE);

ti.TOOLINFO
ti\cbSize   = SizeOf(TOOLINFO);
ti\uFlags   = #TTF_SUBCLASS   ;
ti\hwnd     = WindowID(0)
ti\hinst    = GetModuleHandle_(0)
ti\lpszText = @"This is your tooltip string."
GetClientRect_(WindowID(0), @ti\rect);
SendMessage_(hwndTT, #TTM_ADDTOOL, 0, @ti); 

AddWindowTimer(0, 123, 1000)

SetWindowColor(0,col) ;RGB(0,255,0))
Repeat
  EventID = WaitWindowEvent()
  Select EventID
      
    Case #PB_Event_Menu
      Select EventMenu()
        Case #mnu_s10 :
          ws=10
          SetRect_(moverect.RECT,0,0,ws*6,ws*4)
          ResizeWindow(0,WindowX(0),WindowY(0),ws*6,ws*4)
          SetMenuItemState(0,#mnu_s10,1)
          SetMenuItemState(0,#mnu_s20,0)
        Case #mnu_s20 :
          ws=20
          SetRect_(moverect.RECT,0,0,ws*6,ws*4)
          ;ResizeWindow(0,ws,ws,ws*6,ws*4)
          ResizeWindow(0,WindowX(0),WindowY(0),ws*6,ws*4)
          SetMenuItemState(0,#mnu_s10,0)
          SetMenuItemState(0,#mnu_s20,1)
          
        Case #mnu_color:
          Color = ColorRequester()
          If Color > -1
            col=color
            SetWindowColor(0,col)
          EndIf
          
        Case #mnu_exit:Break
      EndSelect
      
    Case #PB_Event_RightClick
      DisplayPopupMenu(0,WindowID(0))
    Case #PB_Event_Timer
      If EventTimer() = 123
        ;t$="163359"
        t$ = FormatDate("%hh:%ii:%ss,%mm/%dd/%yyyy", Date())
        ti\lpszText = @t$
        SendMessage_(hwndTT, #TTM_UPDATETIPTEXT, 0, @ti); 
        t$ = FormatDate("%hh%ii%ss", Date())
        wrgn.l=CreateRectRgnIndirect_(r)
        For i=1 To 6
          v=Val( Mid(t$,i,1) )
          ;          Debug v
          For j=0 To 3
            If v&(1<<(3-j))
              ;     int nLeftRect,	// x-coordinate of region's upper-left corner 
              ;     int nTopRect,	// y-coordinate of region's upper-left corner 
              ;     int nRightRect,	// x-coordinate of region's lower-right corner  
              ;     int nBottomRect 	// y-coordinate of region's lower-right corner  
              hrgn.l=CreateRectRgn_((i-1)*ws,j*ws,(i-1)*ws+ws-1,j*ws+ws-1)
              CombineRgn_(wrgn, wrgn, hrgn, #RGN_OR)
              DeleteObject_(hrgn)
            EndIf
          Next j
        Next i
        hrgn=CreateRectRgnIndirect_(r)
        CombineRgn_(wrgn, wrgn, hrgn, #RGN_XOR)
        DeleteObject_(hrgn)
        SetWindowRgn_(WindowID(0),wrgn,1)
        DeleteObject_(wrgn)
      EndIf
    Case #WM_LBUTTONDOWN
      
      ; where's the cursor?
      x = EventlParam()&$FFFF
      y = EventlParam()>>16
      
      ; is it in the move rectangle?
      If PtInRect_(moverect, x | (y<<32))
        ; yes
        SendMessage_(WindowID(0),#WM_NCLBUTTONDOWN,#HTCAPTION,0)
      EndIf
  EndSelect
Until EventID = #PB_Event_CloseWindow

If CreateFile(0,"dc.dat")
  WriteLong(0,ws)
  WriteLong(0,col)
  CloseFile(0)
EndIf
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 145
; FirstLine = 118
; EnableUnicode
; EnableXP
; UseIcon = dc.ico
; Executable = dc.exe